Extended information of Semantic Definition Format (SDF) for Digital Twin
Internet-Draft draft-lee-asdf-digital-twin-04
Hyunjeong Lee, Ed.
Electronics and Telecommunications Research Institute
218 Gajeong-ro, Yuseong-gu
Daejeon
34129
South Korea
+82 42 860 1213
hjlee294@etri.re.kr
Joo-Sang Youn
DONG-EUI University
176 Eomgwangno Busan_jin_gu
Busan
47340
South Korea
+82 51 890 1993
joosang.youn@gmail.com
Yong-Geun Hong
Daejeon University
62 Daehak-ro, Dong-gu
Daejeon
34520
South Korea
+82 42 280 4841
yonggeun.hong@gmail.com
ART
ASDF Working Group
Internet-Draft
An SDF specification can describe the definition of Things, i.e., physical objects and their associated interactions, and express the various information that is exchanged for these interactions. Therefore, the SDF format can be used to define the behavior of an object and its associated data model and interaction model in a digital twin system that includes the object as a component. In a digital twin system, interactions between physical and virtual objects, as well as interactions of objects existing in different digital twin systems, are performed over a network, making it important to provide location information of objects during interactions. This document specifies the extension of SDF to represent the location information of objects.

Introduction
A digital twin is a digital representation of an object of interest and may require different capabilities (e.g., synchronization, real-time support) according to the specific domain of application. [Y.4600]. Digital twin systems help organizations improve important functional objectives, including real-time control, off-line analytics, and predictive maintenance, by modeling and simulating objects in the real world. Therefore, it is important for a digital twin system to represent as much real-world information about the object as possible when digitally representing the object. A procedure for representing an observable Thing, as known as a physical asset or an object of interest, as a digital twin in a domain is as follows:
- defining a purpose for expressing the observable object as a digital twin in the domain
- organizing data based on the roles of the observable object in the domain
- configuring the observable object into the digital twin based on the data for the purposes
- interworking with a digital twin of each of other domains in which the observable object performs a different role
- synchronizing the observable object and the digital twin
Nowadays, digital twin systems are applied in various domains including medical, manufacturing, farm, transportation, etc. And a common format is needed to represent the objects in the domains as digital twins. An SDF specification [I-D.ietf-asdf-sdf] can be used for the purpose of digital representation of objects in a digital twin system. However, because the SDF specification only provides a basic model for digital representation, it cannot represent objects location information.
The location information of the object is the important information to digitally representation of the object. This document extends the basic SDF specification by adding a new keyword "location" to represent an object as a digital twin. This new keyword is needed to adequately represent the current location of the object, which is helpful for users to manage the domain efficiently.
Terminology
This specification uses the terminology specified in [I-D.ietf-asdf-sdf] in particular "Class Name Keyword", "Object", and "Affordance".
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

SDF extension for digital twin
This section defines a new SDF Class Name Keyword, sdfLocation, that can be used to represent the location of a thing or an object as a digital twin. The location definitions are at the class level and describe the use of sdfLocation. [I-D.ietf-laari-asdf-relations].

SDF extension for location
The SDF language uses seven predefined Class Name Keywords, including sdfLocation, for modeling connected Things, as illustrated in Figure 1. The sdfLocation is a new Class Name Keyword and is used to describe physical or logical location of sdfThing or sdfObject.
Add SdfLocation to SDF Models

                           ,--------.
                           |sdfThing|
                           |--------|
                           `--------'

                     ,---------.
                     |sdfObject|
                     |---------|
                     `---------'

            ,-----------.  ,---------.   ,--------.    ,-----------.
            |sdfProperty|  |sdfAction|   |sdfEvent|    |sdfLocation|
            |-----------|  |---------|   |--------|    |-----------|
            `-----------'  `---------'   `--------'    `-----------'
                             |

                         ,-------.
                         |sdfData|
                         |-------|
                         `-------'

The sdfLocation is described using conventional GPS coordinates or postal addresses for physical locations, which enable extensive reuse and interoperability. The sdfLocation is also described by strings or integers for relative locations. Using the example in the [[I-D.ietf-asdf-sdf]], a heater in a boat model can be described as being on a "boat" using GPS coordinates or in a "specific location on the boat" using relative locations (Figure 2).
A simple example of an SDF document

                {
                  "info": {
                    "title": "Example location of a heater in a boat",
                    "version": "2024-10-02",
                    "copyright": "Copyright 2024 digital twin Corp. All rights reserved.",
                    "license": "https://example.com/license"
                  },
                  "namespace": {
                    "location": "https://example.com/location"
                  },
                  "defaultNamespace": "location",
                  "sdfObject": {
                    "boat": {
                      "sdfLocation": {
                          "wgs84": {
                            "latitude": "35.2988233791372",
                            "longitude": "129.25478376484913",
                            "altitude": "0.0"
                          },
                          "postal": {
                            "city": "Ulsan",
                            "post-code": "44110",
                            "country": "South Korea"
                          },
                          "w3w": "toggle.mopped.garages"
                      }
                    }
                  }
                }

Architecture of Digital Twin
The architecture of a digital twin based on the SDF model is illustrated in Figure 3, , following the guidelines of [ISO23247-3].
The Physical Layer comprises affordance and non-affordance objects. From the real-world objects, only those deemed relevant are selected for representation as digital twins. The Digital Twin Layer is structured into three sublayers: the Device Communication Sublayer, the Digital Twin Sublayer, and the Application Sublayer. The Device Communication Sublayer is responsible for monitoring and collecting data from both affordance and non-affordance objects. This sublayer provides the necessary data to synchronize the physical objects with their digital twin counterparts. The Digital Twin Sublayer ensures synchronization between the affordance and non-affordance objects and their respective digital twins using the data provided by the Device Communication Sublayer. The Application Sublayer presents the synchronized values of the digital twins to users, facilitating informed decision-making.
Basic Architecture of digital twin

        +---------------------------------------------+ - - - - - - - - - - -
        |            Application Sublayer             |
        | +----------+ +------+ +--------+ +--------+ |
        | |  Human   | | HMI  | |  Apps  | |  Peer  | |
        | +----------+ +------+ +--------+ +--------+ |
        +---------------------------------------------+
        |           Digital Twin Sublayer             |
        | +----------+ +-------------+ +------------+ |
        | | Operation| | Application | | Resource   | |
        | |    and   | |     and     | | access and | |
        | |management| |   service   | |interchange | |
        | +----------+ +-------------+ +------------+ |
        | +-----------------------------------------+ |  Digital twin Layer
        | |     Digital representation of objects   | |
        | |   +-------------+   +----------------+  | |
        | |   |  Affordance |   | Non-Affordance |  | |
        | |   |   objects   |   |    objects     |  | |
        | |   +-------------+   +----------------+  | |
        | +-----------------------------------------+ |
        +---------------------------------------------+
        |        Device Communication Sublayer        |
        |     +-------------+   +----------------+    |
        |     |    Data     |   |     Object     |    |
        |     | collection  |   |     control    |    |
        |     +-------------+   +----------------+    |
        +---------------------------------------------+ - - - - - - - - - - -
        |     +-------------+   +----------------+    |
        |     |  Affordance |   | Non-Affordance |    |
        |     |   objects   |   |    objects     |    |     Physical Layer
        |     +-------------+   +----------------+    |
        +---------------------------------------------+ - - - - - - - - - - -

In order to send an IPv6 packet over OWC, the packet MUST be passed down to the LLC sublayer. For IPv6 addressing or address configuration, the LLC sublayer MUST provide related information, such as link-layer addresses, to its upper layer.
Qualities of sdfLocation
This section defines the qualities of the sdfLocation. These qualities are used to define the potential type of the sdfLocation. A named definition entry in an sdfProperty may be associated with some protocol affordance to enable the application to obtain the location of sdfThing or sdfObject.
Qualities of sdfLocation
Quality | Type | Description
(common) | | Section 4.6 in [I-D.ietf-asdf-sdf]
locationType | string | What kind of location these definitions have
target | string | Target model for the location
description | string | Description of the location
label | string | Short text describing the location
property | object | Additional properties for this location
$comment | string | Additional comments for implementors

locationType
The locationType quality describes the type of location including geographical or relative information [ISO23247-3]. This can use different descriptions, such as geographical information, postal address, w3w and indoor location. The purpose of the locationType is to represent the current location of an sdfThing or an sdfObject. For example, if the locationType is w3w, the location of an object can be describe as "nutrients.snows.voting".

target
The "target" field defines to which definition or ontology term this definition with sdfLocation has a location to. For example, this can be #/sdfObject/location, when the target location of an object is defined in the same SDF model.

            sdfObject: {
              "Humidity": {
                "description": "Example Humidity object",
                "sdfProperty": {
                  ...
                },
                "sdfLocation": {
                  "postalAddr": {
                      "locationType": "postalAddr",
                      "description": "postal address of an object",
                      "label":"postcode"
                  }
                }
              }
            ...
            }

description
The "description" field specifies the location, which is represented as a string.

label
The "label" field is a short text describing the location, similar to the label quality in other SDF definitions.

Examples of Location description

Postal address
This description allows you to describe location of sdfThing or sdfObject with postal address.

            sdfObject: {
              "example-object": {
                "description": "example object",
                "sdfProperty": {
                  ...
                },
                "sdfLocation": {
                  "postalAddr": {
                      "locationType": "postalAddr",
                      "description": "Postal address of a company", "218 Gajeong-ro ...",
                      "label":"34129"
                  }
                }
              }
            ...

Geographical information
This description allows you to describe location of sdfThing or sdfObject with geographical information.

              sdfObject: {
                "BoatDetector": {
                  "sdfLocation": {
                    "wgs84" : {
                        "latitude": "35.5188233791372",
                        "longitude": "129.37308376484913",
                        "altitude": "0.0"
                    }
                  }
                }
              }

Relative information
This description allows you to describe location of sdfThing or sdfObject with relative information including geographical information.

              sdfObject: {
                "sdfLocation": {
                    "wgs84" : {
                        "latitude": "string",
                        "longitude": "string"
                        "altitude": "string"
                    }
                     "relativeLocation" : {
                        "relative-x": "integer",
                        "relative-y": "integer"
                        "relative-z": "integer"
                        "unit":"cm"
                    }
                      ...
                    "Boat_#1": {
                        "latitude": "35.5188233791372",
                        "longitude": "129.37308376484913",
                        "altitude": "0.0"
                    }
                    "Heater_A_in_the_Boat_#1": {
                        "latitude": "35.5188233791372",
                        "longitude": "129.37308376484913",
                        "altitude": "0.0"
                        "relative-x": "7215",
                        "relative-y": "1324"
                        "relative-z": "217"
                    }

                }
              }

Requirements for digital twin
Overview
A digital twin is a partial representation of an sdfThing or sdfObject including characteristics such as sdfProperty, sdfData, and sdfLocation[ISO23247-1]. By representing sdfThing and sdfObject as digital twins, changes that have occurred and require appropriate action can be quickly detected and controlled. The requirements defined in [ISO23247-1] can be applied to represent sdfThings and sdfObjects as digital twins.
Data acquisition
Data related to sdfThing and sdfObject, such as sdfProperty, sdfData, and sdfLocation, should be collected from IP and non-IP devices.
Data analysis
The collected data needs to be analyzed to understand the state of sdfThing and sdfObject.
Identification
The sdfThings and sdfObjects should contain data that uniquely identifies them as digital twins.
Accuracy
The sdfThings and sdfObjects should be represented as digital twins with appropriate levels of detail and accuracy, depending on the application.
Synchronization
The sdfThings and sdfObjects should be synchronized with their digital twins in real-time as appropriate for the application. Newly added or removed sdfThings and sdfObjects should be recognized and reflected in the digital twin.
Security Considerations
Only authorized users should have the authority to manage sdfThings and sdfObjects.
IANA Considerations
This document has no IANA actions.

Normative References
[Y.4600]

"Recommendation ITU-T Y.4600 (2022), Requirements and capabilities of a digital twin system for smart cities.
International Telecommunication Union
August 2022
[I-D.ietf-asdf-sdf]

Semantic Definition Format (SDF) for Data and Interactions of Things
Michael Koster
KTC
Carsten Bormann
Universität Bremen TZI
Ari Keränen
Ericsson
29 February 2024
Internet-Draft draft-ietf-asdf-sdf-18
[I-D.ietf-laari-asdf-relations]

Extended relation information for Semantic Definition Format (SDF)
Petri
Ericsson
20 June 2024
Internet-Draft I-D.ietf-laari-asdf-relations
[ISO23247-1]

Automation systems and integration Digital twin framework for manufacturing - Part 1: Overview and general principles, ISO 23247-1.
ISO
October 2021
[ISO23247-3]

Automation systems and integration Digital twin framework for manufacturing - Part 3: Digital representation of manufacturing elements, ISO 23247-3.
ISO
October 2021
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174

Informative References
[saref4bldg]

SAREF extension for building
Mara Poveda-Villaln
Ral Garcia-Castro
05 June 2020